// Author: A.Voss@FH-Aachen.de
//
// program shows how to start multiple threads
// tags: thread

#include <iostream>
#include <thread>
#include <condition_variable>
#include <chrono>
#include <string>
using namespace std;

#include "../../include/tools.h"

// thread-function
void Work(int secs) 
{
    tools_log(); cout << "thread no " << secs << " started, sleep for " << secs/2.0 << " sec" << endl;

    // sleep for n/2 sec
    this_thread::sleep_for(chrono::milliseconds(secs*500));
   
    tools_log(); cout << "thread done" << endl;     
}

int main()
{
    const int numthreads = 5;

    tools_log(); cout << "start " << numthreads << " threads " << endl;

    // we have 5 thread objects, but no thread is started up to now
    thread threads[numthreads];
    
    // now start the thread with one parameter (i)
    for (int i=0; i<numthreads; ++i)
        threads[i] = thread(Work,i);
       
    tools_log(); cout << "and wait for join" << endl;

    // wait for all threads, note that t is modified (ref &)
    for (auto & t : threads)
        t.join();

    tools_log(); cout << "joined, done" << endl;
    
    return EXIT_SUCCESS;
}
